#include "Say.h"
#include "AIMNetThread.h"

//---------------------------------------------------------------------

// Send message function
void AIMNetThread::SendMessage( BMessage* msg ) {

	char value[2048];
	DataContainer Message;
	SNAC_Object sendMsg;
	char *i, *q;
	int l = 1;

	// Wrap the message in some generic HTML (AOL style)
	Message << "<HTML><BODY BGCOLOR=\"#ffffff\">";

	// parse the message, looking for newlines, and insert <br>'s instead
	i = q = (char*)msg->FindString("message");
	if( i ) {
		while( *i ) {
			if( *i == char(10) ) {
				strncpy( value, q, l );
				value[l-1] = '\0';
				Message << value;
				Message << "<BR>";
				l = 0;
				q = i+1;
			}
			++i; ++l;
		}
		if( i != q )
			Message << q;
	}
	
	//Message << msg->FindString("message");

	// add the closing HTML tag
	Message << "</HTML>";
	
	char tst[2048];
	strncpy( tst, Message.c_ptr(), Message.length() );
	tst[Message.length()] = '\0';
	printf( "OUTGOINGK: %s\n\n", tst );
	
	// Make the SNAC object for the message
	sendMsg.Update( 0x04, 0x06, 0x00, 0x00, 0x2718 );
	sendMsg.data << ToAIMWord(0x00) << ToAIMWord(0x00)
				 << ToAIMWord(0x00) << ToAIMWord(0x00)
				 << ToAIMWord(0x01)
				 << char(strlen((char*)msg->FindString("send_to")))		// sn length
				 << (char*)msg->FindString("send_to")					// sn
				 << ToAIMWord(0x02)
				 //<< ToAIMWord(strlen(Message) + 0x0D)					// msg len + 0x0D
				 << ToAIMWord(Message.length() + 0x0D)					// msg len + 0x0D
				 << char(0x05) << ToAIMWord(0x0100)
				 << ToAIMWord(0x0101) << ToAIMWord(0x0101)
				 //<< ToAIMWord(strlen(Message) + 0x04)					// msg len + 0x04
				 << ToAIMWord(Message.length() + 0x04)					// msg len + 0x04
				 << ToAIMWord(0x00) << ToAIMWord(0x00)
				 << Message;

	// Now that we've gone to all the trouble of making that, send it
	SendSNACPacket( sendMsg );
}

//---------------------------------------------------------------------

void AIMNetThread::DecodeBuddyStuff( DataContainer data, short& i, BMessage* values ) {

	char snLength;
	char* sn;
	unsigned short warningLevel, numTLVs, typeCode,
				   tlvLen, userClass, idleTime, temp;
	time_t memberSince = 0, onSince = 0;

	struct tm* t_s; // to get localtime(time_t t)

	// Get the screen name
	snLength = data[i++];
	sn = new char[snLength+1];
	strncpy( sn, data.getrange(i,snLength).c_ptr(), snLength );
	sn[snLength] = '\0';
	i += snLength;
	if( values )
		values->AddString( "userid", sn );	
	
	printf( "BUDDY_TLV... screen name (%d chars): %s\n", (int)snLength, sn );
	delete sn;
	
	// Get the sender's warning level
	warningLevel = (unsigned short)GetWord( data, i );
	i += 2;
	if( values )
		values->AddInt32( "warninglevel", (int32)warningLevel );	
	
	printf( "BUDDY_TLV... warning level %d\n", warningLevel );
	
	// Get the number of TLV's in the packet
	numTLVs = (unsigned short)GetWord( data, i );
	i += 2;

	printf( "BUDDY_TLV... %d TLV's in this packet\n", numTLVs );
	
	// Go through and grab the rest of the TLV's
	for( unsigned short j = 0; j < numTLVs; ++j ) {
	
		// Grab the type code and length
		typeCode =	(unsigned short)GetWord( data, i );
		tlvLen = (unsigned short)GetWord( data, i+2 );
		i += 4;

		// grab data based on the type code
		switch( typeCode ) {
		
			case 0x01:	// class... 0x10=free, 0x04=AOL
				userClass = (unsigned short)GetWord( data, i );
				i += 2;
				if( values && userClass == 0x10 )
					values->AddString( "userclass", "Internet" );
				else if( values && userClass == 0x04 )
					values->AddString( "userclass", "AOL" );
				else if( values )
					values->AddString( "userclass", "Unknown" );

				if( userClass == 0x10 )
					printf( "BUDDY_TLV... Class = Non-AOL (probably AIM)\n" );
				else if( userClass == 0x04 )
					printf( "BUDDY_TLV... Class = AOL user\n" );
				else
					printf( "BUDDY_TLV... Class = Huh? (unknown, val=0x%X)\n", userClass );
				break;
				
			case 0x02:	// member since date
				temp = (unsigned short)GetWord( data, i );
				memberSince = (temp << 16) + (unsigned short)GetWord( data, i+2 );
				i += 4;
				if( values )
					values->AddData( "membersince", B_TIME_TYPE, (void*)&memberSince, sizeof(time_t) );
				
				t_s = localtime( &memberSince );
				printf( "BUDDY_TLV: Member since date: %s", asctime(t_s) );				
				break;
			
			case 0x03:	// online since date
				temp = (unsigned short)GetWord( data, i );
				onSince = (temp << 16) + (unsigned short)GetWord( data, i+2 );
				i += 4;
				if( values )
					values->AddData( "onsince", B_TIME_TYPE, (void*)&onSince, sizeof(time_t) );
				
				t_s = localtime( &onSince );
				printf( "BUDDY_TLV: Online since: %s", asctime(t_s) );				
				break;			
			
			case 0x04:	// idle time
				idleTime = (unsigned short)GetWord( data, i );
				i += 2;
				if( values )
					values->AddInt32( "idletime", (int32)idleTime );
				
				printf( "BUDDY_TLV: Idle time: %u\n", idleTime );
				break;
		
			default:	// something unknown... just skip it
				printf( "BUDDY_TLV: Unknown TLV: type 0x%X length (%d)\n", typeCode, tlvLen );
				i += tlvLen;
		}	
	}
}

//---------------------------------------------------------------------

void AIMNetThread::BuddyOnline( SNAC_Object& snac ) {

	short i = 0;
	BMessage* newBuddy = new BMessage( BEAIM_ONCOMING_BUDDY );
	
	// The buddy info comes at the beginnning... yank it out
	DecodeBuddyStuff( snac.data, i, newBuddy );
	
	// Send the message
	SendAppMessage( newBuddy );
}

//---------------------------------------------------------------------

void AIMNetThread::BuddyOffline( SNAC_Object& snac ) {

	char name[DISPLAY_NAME_MAX];
	BMessage* oldBuddy = new BMessage( BEAIM_OFFGOING_BUDDY );
	char len;
	
	// get the screen name
	len = snac.data[0];
	printf( "logoff name len: %d\n", int(len) );

	snac.data << char(0);	
	strcpy( name, snac.data.c_ptr() + 1 );
	printf( "offgoing name: %s\n", name );
	
	
	oldBuddy->AddString( "userid", name );
	
	SendAppMessage( oldBuddy );	
}

//---------------------------------------------------------------------

// Receive message function
void AIMNetThread::ReceiveMessage( SNAC_Object& snac ) {

	short i = 10;
	unsigned short temp, temp2;
	unsigned int languageValue;
	bool autoRespond = false;
	BMessage* incomingMsg = new BMessage(BEAIM_INCOMING_IM);
	DataContainer msg;
	
	// Grab the other person's info
	DecodeBuddyStuff( snac.data, i, incomingMsg );
	
	// This will be either 0x0002 or 0x0004 (autorespond mode?)
	temp = (unsigned short)GetWord( snac.data, i );
	i += 2;
	if( temp == 0x0004 ) {
		temp = (unsigned short)GetWord( snac.data, i );		// 0x0000
		temp = (unsigned short)GetWord( snac.data, i+2 );	// 0x0002
		autoRespond = true;
		i += 4;
	}
	
	if( autoRespond )
		printf( "AutoResponded IM...\n" );
	
	// Reality check
	if( temp != 0x0002 )
		printf( "RECV_MESSAGE ERROR: temp should be 0x0002, not 0x%X!\n", temp );
	
	// Get the message length (with 0x0D tacked on), and fixed value 0x0501
	temp = (unsigned short)GetWord( snac.data, i );
	temp = (unsigned short)GetWord( snac.data, i+2 );
	i += 4;
	
	// Another reality check
	if( temp != 0x0501 )
		printf( "RECV_MESSAGE ERROR: temp should be 0x0501, not 0x%X!\n", temp );
	
	// Grab the mysterious language value
	temp = (unsigned short)GetWord( snac.data, i );
	temp2 = (unsigned short)GetWord( snac.data, temp + i + 8 );
	languageValue = (temp2 << 16) + (unsigned short)GetWord( snac.data, temp + i + 6 );
	incomingMsg->AddInt32( "languagevalue", (int32)languageValue );
	i += 2;	
	
	printf( "Mysterious Language value: 0x%X\n", (unsigned)languageValue );
	
	// Get the message itself
	msg = snac.data.getrange( temp + i + 8 );
	msg << char(0);
	incomingMsg->AddString( "message", (char*)msg.c_ptr() );
	
	printf( "actual message: %s\n", msg.c_ptr() );
	
	// Send the message off its final resting place... the great bit-bucket in the sky
	incomingMsg->AddInt32( "wtype", (int32)USER_MESSAGE_TYPE );
	SendAppMessage( incomingMsg );
}

//---------------------------------------------------------------------

// Requests the info and profile for a member
void AIMNetThread::RequestPersonInfo( BMessage* msg ) {

	printf( "requesting person info... %s\n", msg->FindString("userid") );

	// Make the SNAC object
	SNAC_Object snac( 0x02, 0x05, 0, 0, requestID );
	snac.data << ToAIMWord(0x0001)
			  << char(strlen(msg->FindString("userid")))
			  << msg->FindString("userid");
			  
	// add an object to the pending list
	userRequestID rid;
	strcpy( rid.userid, msg->FindString("userid") );
	rid.reqID = requestID++;
	rid.type = RID_GET_INFO;
	pendingRequests.Add( rid );

	// and send it!
	SendSNACPacket( snac );
}

//---------------------------------------------------------------------

// Requests the info and profile for a member
void AIMNetThread::ReceivePersonInfo( SNAC_Object& snac ) {

	// vars
	BMessage* incomingInfo = new BMessage(BEAIM_UPDATE_INFO);
	unsigned short type, length;
	DataContainer temp;	
	short i = 0;

	// Grab the other person's info (from the beginning)
	DecodeBuddyStuff( snac.data, i, incomingInfo );
	
	// get the encoding value and the profile (if they are there)
	if( i < snac.data.length() ) {
		
		// There should be two TLV's in here...
		for( int j = 0; j < 2; ++j ) {
		
			// get the type and the length
			type = (unsigned short)GetWord( snac.data, i );
			length = (unsigned short)GetWord( snac.data, i+2 );
			i += 4;
			
			// get the data
			temp = snac.data.getrange( i, length );
			temp << char(0);
			i += length;

			// the profile encoding
			if( type == 0x01 ) {
				printf( "Profile encoding:\n%s\n", temp.c_ptr() );
				incomingInfo->AddString( "encoding", temp.c_ptr() );
			}

			// the profile itself
			else if( type == 0x02 ) {
				printf( "> Profile:\n%s\n", temp.c_ptr() );
				incomingInfo->AddString( "profile", temp.c_ptr() );
			}
		}	
	}

	// Find this request in the pending list and delete it
	userRequestID btemp;
	int curPos = 0;
	bool keepGoing = pendingRequests.First(btemp);
	char* ctemp = (char*)incomingInfo->FindString("userid");
	while( keepGoing ) {
		if( CompareScreenNames(btemp.userid, ctemp) ) {
			pendingRequests.Delete(curPos);
			break;
		}
		keepGoing = pendingRequests.Next(btemp);
		++curPos;
	}

	// bombs away...
	incomingInfo->AddInt32( "wtype", (int32)USER_INFO_TYPE );
	SendAppMessage( incomingInfo );
}

//---------------------------------------------------------------------

void AIMNetThread::UpdateServerBuddyList( BMessage* msg ) {

	// Set up a SNAC object, with the correct fields to ADD (not remove) a person
	SNAC_Object snac( 0x03, 0x04, 0, 0, 0x1015 );
	
	// other vars we're gonna need (mostly to parse the list)
	int l = 1;
	char* i = (char*)msg->FindString("list");
	char* q = i;
	char name[50];
	
	if( msg->FindBool("add") )
		printf( "ADDING to server buddy list\n" );
	else
		printf( "REMOVING from server buddy list\n" );
	

	// are we adding to or removing from the server's buddy list?
	bool add = msg->FindBool("add");
	
	// the add command apparently has three sets of zeroes before the name list
	if( add )
		snac.data << ToAIMWord(0x00) << ToAIMWord(0x00) << ToAIMWord(0x00);

	// Go through and pull out all the names
	if( i ) {
		while( *i ) {
			if( *i == 9 ) {
				strncpy( name, q, l );
				name[l-1] = '\0';
				if( add ) snac.data << char(l-1) << name;
				else SendRemovePersonMessage( name, int(l-1) );
				printf( "(%d): %s\n", int(l-1), name );
				l = 0;
				q = i+1;
			}
			++i; ++l;
		}
		if( i != q ) {
			printf( "(%d): %s\n", int(l-1), q );
			if( add ) snac.data << char(l-1) << q;
			else SendRemovePersonMessage( q, int(l-1) );
		}
	}
	
	// if we are adding screen names, go ahead and send them
	if( add )
		SendSNACPacket( snac );
}

//---------------------------------------------------------------------

void AIMNetThread::SendRemovePersonMessage( char* name, int len ) {

	printf( "REMOVINK: %s\n", name );

	// Set up a SNAC object, with the correct fields to remove a person
	SNAC_Object snac( 0x03, 0x05, 0, 0, 0x1015 );
	snac.data << ToAIMWord(0x00) << ToAIMWord(0x00) << ToAIMWord(0x00);
	snac.data << char(len) << name;
	SendSNACPacket( snac );
}

//---------------------------------------------------------------------

void AIMNetThread::SearchByEmail( BMessage* msg ) {

	// calculate the next request ID
	emailSearchID = requestID++;

	// Set up a SNAC object, with the correct fields to search for an address
	SNAC_Object snac( 0x0a, 0x02, 0x00, 0x00, emailSearchID );
	snac.data << (char*)msg->FindString( "email" );
	SendSNACPacket( snac );
}

//---------------------------------------------------------------------

void AIMNetThread::ReceiveSearchResults( SNAC_Object& snac ) {

	DataContainer name;
	char actualName[50];	
	unsigned short length;
	BMessage* sndMessage;
	short i = 0;

	// is this the current search? If not, ignore it
	if( snac.GetRequestID() != emailSearchID )
		return;

	// go through and suck out all the search results
	while( (snac.data.length() - i) > 4 ) {

		// get 0x0001 (a constant), and the length of the screen name
		GetWord( snac.data, i );
		length = (unsigned short)GetWord( snac.data, i+2 );
		i += 4;
		
		printf( "SR---> SN length: %d chars\n", length );
		
		// get the screen name itself
		name = snac.data.getrange( i, length );
		strncpy( actualName, name.c_ptr(), length );
		actualName[length] = '\0';
		i += length;
		
		printf( "SR---> SN name: %s\n", name.c_ptr() );
		
		// send a message with this match
		sndMessage = new BMessage( BEAIM_EMAIL_SEARCH_RESULTS );
		sndMessage->AddString( "userid", actualName );
		SendAppMessage( sndMessage );
	}
}

//---------------------------------------------------------------------

void AIMNetThread::ReceiveFailedSearch( SNAC_Object& snac ) {

	// is this the current search? If not, ignore it
	if( snac.GetRequestID() != emailSearchID )
		return;
		
	// post a message saying that the search failed
	BMessage* failMessage = new BMessage( BEAIM_EMAIL_SEARCH_RESULTS );
	failMessage->AddBool( "failed", true );
	SendAppMessage( failMessage );	
}

//---------------------------------------------------------------------

void AIMNetThread::FailedPersonInfo( SNAC_Object& snac ) {

	printf( "Failed packet:\n" );

	// Find this request in the pending list and delete it
	userRequestID btemp;
	int curPos = 0;
	bool keepGoing = pendingRequests.First(btemp);
	long ctemp = snac.GetRequestID();
	while( keepGoing ) {
		if( btemp.reqID == (unsigned)ctemp ) {
			pendingRequests.Delete(curPos);
			break;
		}
		keepGoing = pendingRequests.Next(btemp);
		++curPos;
	}
	
	// OK... now fire off a failure message
	if( keepGoing ) {
		BMessage* incomingInfo = new BMessage(BEAIM_UPDATE_INFO);
		incomingInfo->AddInt32( "wtype", (int32)USER_INFO_TYPE );
		incomingInfo->AddString( "userid", btemp.userid );
		incomingInfo->AddString( "profile", "<b>Error:</b> This is an invalid screen name, or this user is not signed on.</b>" );
		SendAppMessage( incomingInfo );
	}
}

//---------------------------------------------------------------------

void AIMNetThread::SendArbitraryData( BMessage* msg ) {

	DataContainer data;
	ssize_t size = 0;
	char* chardata;
	
	// get that data outta there!
	msg->FindData( "data", B_RAW_TYPE, (const void**)(&chardata), &size );
	for( short i = 0; i < size; ++i )
		data << (unsigned char)chardata[i];

	// Send it!
	SendPacket( data, 0x02 );
}

//---------------------------------------------------------------------

void AIMNetThread::SendIdleMessage( bool nowIdle ) {

	SNAC_Object snac;

	// are we idle now?
	if( nowIdle ) {
		snac.Update( 0x01, 0x11, 0x00, 0x00, 0x00 );
		snac.data << ToAIMWord(0x00);
		snac.data << (unsigned char)(2);
		snac.data << (unsigned char)('Z');
		SendSNACPacket( snac );
	}
	
	// nope... guess not
	else {
		snac.Update( 0x01, 0x11, 0x00, 0x00, 0x00 );
		snac.data << ToAIMWord(0x00);
		snac.data << ToAIMWord(0x00);
		SendSNACPacket( snac );	
	}
}
		
//---------------------------------------------------------------------

void AIMNetThread::SendIdlePulse() {


}
		
//---------------------------------------------------------------------