#ifndef _GPREFS_H_
#define _GPREFS_H_

#include <File.h>
#include <Directory.h>
#include <Locker.h>
#include "constants.h"

class GPreferences {

	public:
		GPreferences();
		~GPreferences();
		
		void LoadDefaultUser();
		void LoadUserFile( char*, bool create = true );
		void GetUserLoginParameters( char* user, char* pw, int pwlen, bool& autoLogin, bool& savePassword );
		
		// read/write functions
		void WriteBool( char* name, bool value, bool=false );
		bool ReadBool( char* name, bool def, bool=false );
		
		void WriteString( char* name, char* val, bool=false );
		void ReadString( char* name, char* buf, char* def, unsigned int bufSize, bool=false );
		
		void WriteInt32( char* name, int32 value, bool=false );
		int32 ReadInt32( char* name, int32 def, bool=false );
		
		bool GetNextUser( char* user, bool first = false );

	private:
	
		char UserName[DISPLAY_NAME_MAX];
		BLocker* lock;
		BFile *prefsFile;
		BFile *globalPrefsFile;
		BDirectory *prefsDirectory;
};

#endif
