#include "ProtocolManager.h"
#include "MiscStuff.h"
#include "Say.h"

// This is the BLooper class that will own and handle all the protocol
//   threads. Other functions that want to send data will send it through
//   this class, which will automatically route it to the correct
//   destination.

// Obviously it is rather lacking in power right now, but give it some time
//   and it will rise to the top.

// After all, like sagas, every class has a beginning...

//-------------------------------------------------------------------------

ProtocolManager::ProtocolManager()
			  : BLooper( "protocol_manager", B_LOW_PRIORITY )
{
	lock = new BLocker( "protocol_manager_locker" );
	strcpy( ProgramUser, "" );
	
	// Start the looper
	Run();
}

//-------------------------------------------------------------------------

void ProtocolManager::Close()
{
	delete lock;
	
	// Now tell the BLooper to kill itself
	// "Heh heh... suicide is legal in THIS state, sonny!"
	PostMessage( new BMessage(B_QUIT_REQUESTED) );	
}

//-------------------------------------------------------------------------

void ProtocolManager::SetProgramUser( char* user ) {

	lock->Lock();
	
	// Change the name
	strcpy( ProgramUser, user );
	
	// Tell the prefs and peoplelist modules to load settings for this name
	list->LoadUserSettings( user );
	prefs->LoadUserFile( user );
	
	// enable/disable sounds for this user
	//sounds->SetEnabled( prefs->ReadBool("gm_ps", true) );
	PostAppMessage( new BMessage(BEAIM_RELOAD_PREF_SETTINGS) );

	lock->Unlock();
}

//-------------------------------------------------------------------------

void ProtocolManager::GetProgramUser( char* user ) {

	lock->Lock();
	strcpy( user, ProgramUser );
	lock->Unlock();
}

//-------------------------------------------------------------------------

void ProtocolManager::TranslatePersonToDisplay( unsigned int proto, char* name, char* dn ) {

	lock->Lock();

	//strcpy( dn, "~" );
	dn[0] = '\0';
	strcat( dn, name );
	
	lock->Unlock();
}

//-------------------------------------------------------------------------